Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs	(revision 13787)
@@ -508,6 +421,21 @@
 
     private System.Windows.Forms.Panel seedingStrategyPanel;
+    private System.Windows.Forms.Button algorithmStartButton;
+    private System.Windows.Forms.Label seedingStrategyLabel;
+    private System.Windows.Forms.Label evaluationsLimitabel;
+    private System.Windows.Forms.ComboBox suggestedInstancesComboBox;
+    private System.Windows.Forms.Button algorithmCloneButton;
+    private Data.Views.StringConvertibleValueView maxEvaluationsView;
+    private System.Windows.Forms.Label minimumTargetLabel;
+    private Data.Views.StringConvertibleValueView minTargetView;
+    private System.Windows.Forms.Label instanceLabel;
     private MainForm.WindowsForms.DragOverTabControl solverTabControl;
     private System.Windows.Forms.TabPage resultsTabPage;
+    private System.Windows.Forms.CheckBox showOnlyFinalResultCheckBox;
+    private WeifenLuo.WinFormsUI.Docking.DockPanel resultsDockPanel;
+    private System.Windows.Forms.TabPage runsTabPage;
+    private Optimization.Views.RunCollectionView runsView;
+    private System.Windows.Forms.TabPage seededRunsTabPage;
+    private Optimization.Views.RunCollectionView seededRunsView;
     private System.Windows.Forms.TabPage solutionSeedingTabPage;
     private System.Windows.Forms.TabPage parametersTabPage;
@@ -515,24 +443,4 @@
     private System.Windows.Forms.TabPage operatorGraphTabPage;
     private MainForm.WindowsForms.ViewHost operatorGraphViewHost;
-    private System.Windows.Forms.Button algorithmStartButton;
-    private System.Windows.Forms.Label seedingStrategyLabel;
-    private System.Windows.Forms.Label evaluationsLimitabel;
-    private System.Windows.Forms.Label recommenderLabel;
-    private System.Windows.Forms.ComboBox suggestedInstancesComboBox;
-    private System.Windows.Forms.Button algorithmCloneButton;
-    private System.Windows.Forms.TabPage runsTabPage;
-    private Optimization.Views.RunCollectionView runsView;
-    private Data.Views.StringConvertibleValueView maxEvaluationsView;
-    private WeifenLuo.WinFormsUI.Docking.DockPanel resultsDockPanel;
-    private System.Windows.Forms.CheckBox showOnlyFinalResultCheckBox;
-    private System.Windows.Forms.TabPage seededRunsTabPage;
-    private Optimization.Views.RunCollectionView seededRunsView;
-    private System.Windows.Forms.Label minimumTargetLabel;
-    private Data.Views.StringConvertibleValueView minTargetView;
-    private System.Windows.Forms.ComboBox recommenderComboBox;
-    private System.Windows.Forms.SplitContainer solverSplitContainer;
-    private MainForm.WindowsForms.ViewHost recommenderViewHost;
-    private System.Windows.Forms.Label instanceLabel;
-    private System.Windows.Forms.Button recommendRefreshButton;
   }
 }
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs	(revision 13787)
@@ -28,4 +28,5 @@
 using HeuristicLab.OptimizationExpertSystem.Common;
 using System;
+using System.Linq;
 using System.Windows.Forms;
 
@@ -44,6 +45,4 @@
       algorithmCloneButton.Text = string.Empty;
       algorithmCloneButton.Image = VSImageLibrary.Clone;
-      recommendRefreshButton.Text = string.Empty;
-      recommendRefreshButton.Image = VSImageLibrary.Refresh;
       seedingStrategyView = new EnumValueView<SeedingStrategyTypes>() {
         Dock = DockStyle.Fill
@@ -68,5 +67,4 @@
           seedingStrategyView.Content = null;
           seedingSolutionsView.Content = null;
-          recommenderViewHost.Content = null;
         } else {
           maxEvaluationsView.Content = Content.MaximumEvaluations;
@@ -76,9 +74,7 @@
           seedingStrategyView.Content = Content.SeedingStrategy;
           seedingSolutionsView.Content = Content.SolutionSeedingPool;
-          recommenderViewHost.Content = Content.AlgorithmInstanceRecommender;
         }
       } finally { SuppressEvents = false; }
       UpdateSuggestedInstancesCombobox();
-      UpdateRecommenderCombobox();
     }
 
@@ -91,4 +87,23 @@
     }
 
+    #region Update Controls
+    private void UpdateSuggestedInstancesCombobox() {
+      var prevSelection = (AlgorithmInstanceItem)suggestedInstancesComboBox.SelectedItem;
+      var prevNewIndex = -1;
+      suggestedInstancesComboBox.Items.Clear();
+      if (Content == null) return;
+
+      var ranking = Content.GetAlgorithmInstanceRanking().ToList();
+
+      for (var i = 0; i < ranking.Count; i++) {
+        suggestedInstancesComboBox.Items.Add(new AlgorithmInstanceItem(ranking[i]));
+        if (prevSelection == null || ranking[i].Item1.Name == prevSelection.Item.Item1.Name)
+          prevNewIndex = prevSelection == null ? 0 : i;
+      }
+      suggestedInstancesComboBox.SelectedIndex = prevNewIndex;
+    }
+    #endregion
+
+    #region Content Event Handlers
     protected override void OnAlgorithmInstanceStarted(IAlgorithm algorithm) {
       base.OnAlgorithmInstanceStarted(algorithm);
@@ -97,54 +112,19 @@
     }
 
-    protected override void OnSuggestedInstancesChanged() {
-      base.OnSuggestedInstancesChanged();
+    protected override void OnRecommendationModelChanged() {
+      base.OnRecommendationModelChanged();
       UpdateSuggestedInstancesCombobox();
     }
+    #endregion
 
-    private void UpdateSuggestedInstancesCombobox() {
-      var prevSelection = (IAlgorithm)suggestedInstancesComboBox.SelectedItem;
-      var prevNewIndex = -1;
-      suggestedInstancesComboBox.Items.Clear();
-      if (Content == null) return;
-
-      for (var i = 0; i < Content.AlgorithmInstances.Count; i++) {
-        suggestedInstancesComboBox.Items.Add(Content.AlgorithmInstances[i]);
-        if (prevSelection == null || Content.AlgorithmInstances[i].Name == prevSelection.Name)
-          prevNewIndex = prevSelection == null ? 0 : i;
-      }
-      if (prevNewIndex >= 0) suggestedInstancesComboBox.SelectedIndex = prevNewIndex;
-    }
-
-    private void UpdateRecommenderCombobox() {
-      var prevSelection = Content.AlgorithmInstanceRecommender;
-      var prevNewIndex = -1;
-      recommenderComboBox.Items.Clear();
-      if (Content == null) return;
-
-      /*var i = 0;
-      foreach (var type in ApplicationManager.Manager.GetTypes(typeof (IAlgorithmInstanceRecommender))) {
-        var r = (IAlgorithmInstanceRecommender)Activator.CreateInstance(type, BindingFlags.CreateInstance, Content);
-        recommenderComboBox.Items.Add(r);
-        if (prevSelection == null || type == prevSelection.GetType())
-          prevNewIndex = prevSelection == null ? 0 : i;
-        i++;
-      }
-      if (prevNewIndex >= 0) recommenderComboBox.SelectedIndex = prevNewIndex;*/
-      recommenderComboBox.Items.Add(new OverallBestRecommender(Content));
-      if (prevSelection is OverallBestRecommender) recommenderComboBox.SelectedIndex = recommenderComboBox.Items.Count - 1;
-      recommenderComboBox.Items.Add(new KNearestNeighborRecommender(Content));
-      if (prevSelection is KNearestNeighborRecommender) recommenderComboBox.SelectedIndex = recommenderComboBox.Items.Count - 1;
-      recommenderComboBox.Items.Add(new DistanceWeightedRecommender(Content));
-      if (prevSelection is DistanceWeightedRecommender) recommenderComboBox.SelectedIndex = recommenderComboBox.Items.Count - 1;
-    }
-
+    #region Control Event Handlers
     private void AlgorithmStartButtonOnClick(object sender, EventArgs e) {
       if (suggestedInstancesComboBox.SelectedIndex >= 0)
-        Content.StartAlgorithmAsync(suggestedInstancesComboBox.SelectedIndex);
+        Content.StartAlgorithmAsync(Content.AlgorithmInstances.Select((a, i) => new { Alg = a, Index = i}).Single(x => x.Alg.Name == ((AlgorithmInstanceItem)suggestedInstancesComboBox.SelectedItem).Item.Item1.Name).Index);
     }
 
     private void AlgorithmCloneButtonOnClick(object sender, EventArgs e) {
       if (suggestedInstancesComboBox.SelectedIndex >= 0)
-        MainForm.ShowContent((IAlgorithm)Content.AlgorithmInstances[suggestedInstancesComboBox.SelectedIndex].Clone());
+        MainForm.ShowContent((IAlgorithm)Content.AlgorithmInstances[Content.AlgorithmInstances.Select((a, i) => new { Alg = a, Index = i }).Single(x => x.Alg.Name == ((AlgorithmInstanceItem)suggestedInstancesComboBox.SelectedItem).Item.Item1.Name).Index].Clone());
     }
 
@@ -152,5 +132,5 @@
       if (InvokeRequired) { Invoke((Action<object, EventArgs>)SuggestedInstancesComboBoxOnSelectedIndexChanged, sender, e); return; }
       if (suggestedInstancesComboBox.SelectedIndex >= 0) {
-        var alg = Content.AlgorithmInstances[suggestedInstancesComboBox.SelectedIndex];
+        var alg = Content.AlgorithmInstances[Content.AlgorithmInstances.Select((a, i) => new { Alg = a, Index = i }).Single(x => x.Alg.Name == ((AlgorithmInstanceItem)suggestedInstancesComboBox.SelectedItem).Item.Item1.Name).Index];
         solverParametersView.Content = alg.Parameters;
         var engineAlg = alg as EngineAlgorithm;
@@ -163,16 +143,20 @@
       SetEnabledStateOfControls();
     }
+    #endregion
 
-    private void RecommenderComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
-      if (InvokeRequired) { Invoke((Action<object, EventArgs>)RecommenderComboBoxOnSelectedIndexChanged, sender, e); return; }
-      if (recommenderComboBox.SelectedIndex < 0) return;
-      Content.AlgorithmInstanceRecommender = (IAlgorithmInstanceRecommender)recommenderComboBox.SelectedItem;
-      recommenderViewHost.Content = Content.AlgorithmInstanceRecommender;
-      Content.UpdateSuggestions();
+    #region Helper Classes and Methods
+    private class AlgorithmInstanceItem {
+      private readonly Tuple<IAlgorithm, double> item;
+      public Tuple<IAlgorithm, double> Item { get { return item; } }
+
+      public AlgorithmInstanceItem(Tuple<IAlgorithm, double> item) {
+        this.item = item;
+      }
+
+      public override string ToString() {
+        return item.Item2.ToString("F0") + ": " + item.Item1.Name;
+      }
     }
-
-    private void button1_Click(object sender, EventArgs e) {
-      Content.UpdateSuggestions();
-    }
+    #endregion
   }
 }
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingProblemInstanceView.cs	(revision 13787)
@@ -22,7 +22,7 @@
 using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
 using HeuristicLab.Data;
 using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.OptimizationExpertSystem.Common;
 using System;
@@ -39,5 +39,5 @@
   public sealed partial class UnderstandingProblemInstanceView : KnowledgeCenterViewBase {
     private bool SuppressEvents { get; set; }
-    private readonly CheckedItemListView<StringValue> characteristicsView;
+    private readonly CheckedItemList<StringValue> characteristics;
  
     public UnderstandingProblemInstanceView() {
@@ -45,20 +45,22 @@
       showCharacteristicsCheckBox.Text = string.Empty;
       showCharacteristicsCheckBox.Image = VSImageLibrary.Properties;
-      characteristicsView = new CheckedItemListView<StringValue>() {
-        Dock = DockStyle.Fill
-      };
-      mapSplitContainer.Panel2.Controls.Add(characteristicsView);
+      characteristics = new CheckedItemList<StringValue>();
+      characteristics.CheckedItemsChanged += CharacteristicsOnCheckedItemsChanged;
+      mapSplitContainer.Panel2.Controls.Add(new ViewHost() {
+        Dock = DockStyle.Fill,
+        Content = characteristics
+      });
     }
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
+      characteristics.Clear();
       if (Content == null) {
         problemInstancesView.Content = null;
-        characteristicsView.Content = null;
         instanceMapChart.Series["InstancesSeries"].Points.Clear();
         instanceMapChart.Series["CurrentInstanceSeries"].Points.Clear();
       } else {
         problemInstancesView.Content = Content.ProblemInstances;
-        characteristicsView.Content = Content.ProblemCharacteristics;
+        UpdateCharacteristics();
         UpdateProjectionComboBox();
         UpdateSizeComboBox();
@@ -67,19 +69,16 @@
     }
 
-    #region Content Event Handlers
-    protected override void OnProblemChanged() {
-      base.OnProblemChanged();
-      SetEnabledStateOfControls();
-    }
-
-    protected override void OnProblemInstancesChanged() {
-      base.OnProblemInstancesChanged();
-      if (Content.ProblemInstances.UpdateOfRunsInProgress) return;
-      UpdateProjectionComboBox();
-      UpdateSizeComboBox();
-      UpdateColorComboBox();
-      UpdateProjection();
-    }
-    #endregion
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+    }
+
+    #region Update Controls
+    private void UpdateCharacteristics() {
+      var @checked = new HashSet<string>(characteristics.CheckedItems.Select(x => x.Value.Value));
+      characteristics.Clear();
+      foreach (var c in Content.ProblemInstances.ResultNames) {
+        characteristics.Add(new StringValue(c), @checked.Contains(c));
+      }
+    }
 
     private void UpdateProjectionComboBox() {
@@ -126,11 +125,4 @@
       } finally { SuppressEvents = false; }
     }
-    
-    private IEnumerable<string> GetProjections() {
-      return Content.ProblemInstances
-        .SelectMany(x => x.Results.Where(y => Regex.IsMatch(y.Key, "^Projection[.].*[.][XY]$")))
-        .Select(x => Regex.Match(x.Key, "Projection[.](?<g>.*)[.][XY]").Groups["g"].Value)
-        .Distinct();
-    }
 
     private void UpdateProjection() {
@@ -153,4 +145,67 @@
         size, color, invPropCheckBox.Checked, fromZeroCheckBox.Checked);
     }
+    #endregion
+
+    #region Content Event Handlers
+    protected override void OnProblemChanged() {
+      base.OnProblemChanged();
+      SetEnabledStateOfControls();
+    }
+
+    protected override void OnProblemInstancesChanged() {
+      base.OnProblemInstancesChanged();
+      if (Content.ProblemInstances.UpdateOfRunsInProgress) return;
+      try {
+        SuppressEvents = true;
+        UpdateCharacteristics();
+      } finally { SuppressEvents = false; }
+      UpdateProjectionComboBox();
+      UpdateSizeComboBox();
+      UpdateColorComboBox();
+      UpdateProjection();
+    }
+    #endregion
+
+    #region Control Event Handlers
+    private void ProjectionComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+
+    private void SizeComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+
+    private void colorComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+
+    private void InvPropCheckBoxOnCheckedChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+
+    private void fromZeroCheckBox_CheckedChanged(object sender, EventArgs e) {
+      UpdateProjection();
+    }
+
+    private void showCharacteristicsCheckBox_CheckedChanged(object sender, EventArgs e) {
+      mapSplitContainer.Panel2Collapsed = !showCharacteristicsCheckBox.Checked;
+    }
+    #endregion
+
+    #region Other Event Handlers
+    private void CharacteristicsOnCheckedItemsChanged(object sender, EventArgs e) {
+      if (SuppressEvents) return;
+      if (characteristics.CheckedItems.Any())
+        Content.UpdateInstanceProjection(characteristics.CheckedItems.Select(x => x.Value.Value).ToArray());
+    }
+    #endregion
+
+    #region Helper Classes and Methods
+    private IEnumerable<string> GetProjections() {
+      return Content.ProblemInstances.ResultNames
+        .Where(x => Regex.IsMatch(x, "^Projection[.].*[.][XY]$"))
+        .Select(x => Regex.Match(x, "Projection[.](?<g>.*)[.][XY]").Groups["g"].Value)
+        .Distinct();
+    }
 
     private void DoProjectProblemInstances(Series instancesSeries, Series currentInstanceSeries, string projection, string size, string color, bool invProp, bool fromZero) {
@@ -160,5 +215,5 @@
       double maxSize = 0, minSize = 0;
       if (!string.IsNullOrEmpty(size)) {
-        var sizes = Content.ProblemInstances.Where(x => x.Results.ContainsKey(size)).Select(x => x.Results[size]).OfType<Data.DoubleValue>().Where(x => !double.IsNaN(x.Value)).ToList();
+        var sizes = Content.ProblemInstances.Where(x => x.Results.ContainsKey(size)).Select(x => x.Results[size]).OfType<DoubleValue>().Where(x => !double.IsNaN(x.Value)).ToList();
         if (sizes.Count > 0) {
           maxSize = sizes.Max(x => x.Value);
@@ -177,7 +232,7 @@
         var yKey = "Projection." + projection + ".Y";
         if (!run.Results.ContainsKey(xKey) || !run.Results.ContainsKey(yKey)
-            || !(run.Results[xKey] is Data.DoubleValue) || !(run.Results[yKey] is Data.DoubleValue)) continue;
-        var x = ((Data.DoubleValue)run.Results[xKey]).Value;
-        var y = ((Data.DoubleValue)run.Results[yKey]).Value;
+            || !(run.Results[xKey] is DoubleValue) || !(run.Results[yKey] is DoubleValue)) continue;
+        var x = ((DoubleValue)run.Results[xKey]).Value;
+        var y = ((DoubleValue)run.Results[yKey]).Value;
         var dataPoint = new DataPoint(x, y) {
           Label = run.Name,
@@ -185,5 +240,5 @@
         IItem item;
         if (maxSize > minSize && run.Results.TryGetValue(size, out item)) {
-          var dItem = item as Data.DoubleValue;
+          var dItem = item as DoubleValue;
           if (dItem == null && item is IntValue) dItem = new DoubleValue(((IntValue)item).Value);
           if (dItem != null) {
@@ -216,29 +271,4 @@
       }
     }
-
-    #region Control Event Handlers
-    private void ProjectionComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
-      UpdateProjection();
-    }
-
-    private void SizeComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
-      UpdateProjection();
-    }
-
-    private void colorComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      UpdateProjection();
-    }
-
-    private void InvPropCheckBoxOnCheckedChanged(object sender, EventArgs e) {
-      UpdateProjection();
-    }
-
-    private void fromZeroCheckBox_CheckedChanged(object sender, EventArgs e) {
-      UpdateProjection();
-    }
-
-    private void showCharacteristicsCheckBox_CheckedChanged(object sender, EventArgs e) {
-      mapSplitContainer.Panel2Collapsed = !showCharacteristicsCheckBox.Checked;
-    }
     #endregion
   }
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingSolutionsView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingSolutionsView.cs	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/UnderstandingSolutionsView.cs	(revision 13787)
@@ -54,23 +54,6 @@
       UpdateSolutionVisualization();
     }
-
-    protected override void OnProblemChanged() {
-      base.OnProblemInstancesChanged();
-      UpdateSimilarityCalculators();
-      UpdateNamesComboboxes();
-      UpdateSolutionVisualization();
-    }
-
-    protected override void OnProblemSolutionsChanged() {
-      base.OnProblemSolutionsChanged();
-      UpdateNamesComboboxes();
-      UpdateSolutionVisualization();
-    }
-
-    protected override void OnSolutionSeedingPoolChanged() {
-      base.OnSolutionSeedingPoolChanged();
-      UpdateSolutionNetworkAnalysis(similarityComboBox.SelectedItem as ISolutionSimilarityCalculator, (string)solutionNetworkProjectionComboBox.SelectedItem, linesCheckBox.Checked, contrastTrackBar.Value, minimumTrackBar.Value);
-    }
-
+    
+    #region Update Controls
     private void UpdateSimilarityCalculators() {
       var selected = (ISolutionSimilarityCalculator)(similarityComboBox.SelectedIndex >= 0 ? similarityComboBox.SelectedItem : null);
@@ -280,5 +263,27 @@
       }
     }
-
+    #endregion
+
+    #region Content Event Handlers
+    protected override void OnProblemChanged() {
+      base.OnProblemInstancesChanged();
+      UpdateSimilarityCalculators();
+      UpdateNamesComboboxes();
+      UpdateSolutionVisualization();
+    }
+
+    protected override void OnProblemSolutionsChanged() {
+      base.OnProblemSolutionsChanged();
+      UpdateNamesComboboxes();
+      UpdateSolutionVisualization();
+    }
+
+    protected override void OnSolutionSeedingPoolChanged() {
+      base.OnSolutionSeedingPoolChanged();
+      UpdateSolutionNetworkAnalysis(similarityComboBox.SelectedItem as ISolutionSimilarityCalculator, (string)solutionNetworkProjectionComboBox.SelectedItem, linesCheckBox.Checked, contrastTrackBar.Value, minimumTrackBar.Value);
+    }
+    #endregion
+
+    #region Control Event Handlers
     private void SimilarityComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
       if (InvokeRequired) { Invoke((Action<object, EventArgs>)SimilarityComboBoxOnSelectedIndexChanged, sender, e); return; }
@@ -370,6 +375,7 @@
       }
     }
-
-    #region Helpers
+    #endregion
+
+    #region Helper Classes and Methods
     private List<IScope> GetSolutionScopes() {
       return Content.Problem.Solutions.Select(x => x.Solution).OfType<IScope>().ToList();
